# OpenAPI Petstore
#
# This is a sample server Petstore server. For this sample, you can use the api key `special-key` to test the authorization filters.
#
# The version of the OpenAPI document: 1.0.0
# Generated by: https://openapi-generator.tech

#' @docType class
#' @title Fake operations
#' @description petstore.Fake
#' @format An \code{R6Class} generator object
#' @field api_client Handles the client-server communication.
#'
#' @section Methods:
#' \describe{
#' \strong{ FakeDataFile } \emph{ test data_file to ensure it&#39;s escaped correctly }
#' 
#'
#' \itemize{
#' \item \emph{ @param } dummy character
#' \item \emph{ @param } var_data_file character
#' \item \emph{ @returnType } \link{User} \cr
#'
#'
#' \item status code : 200 | successful operation
#'
#' \item return type : User 
#' \item response headers :
#'
#' \tabular{ll}{
#' }
#' }
#'
#' }
#'
#'
#' @examples
#' \dontrun{
#' ####################  FakeDataFile  ####################
#'
#' library(petstore)
#' var.dummy <- 'dummy_example' # character | dummy required parameter
#' var.var_data_file <- 'var_data_file_example' # character | header data file
#'
#' #test data_file to ensure it's escaped correctly
#' api.instance <- FakeApi$new()
#'
#' result <- api.instance$FakeDataFile(var.dummy, var_data_file=var.var_data_file)
#'
#'
#' }
#' @importFrom R6 R6Class
#' @importFrom base64enc base64encode
#' @export
FakeApi <- R6::R6Class(
  "FakeApi",
  public = list(
    api_client = NULL,
    initialize = function(api_client) {
      if (!missing(api_client)) {
        self$api_client <- api_client
      }
      else {
        self$api_client <- ApiClient$new()
      }
    },
    FakeDataFile = function(dummy, var_data_file=NULL, data_file=NULL, ...) {
      api_response <- self$FakeDataFileWithHttpInfo(dummy, var_data_file, data_file = data_file, ...)
      resp <- api_response$response
      if (httr::status_code(resp) >= 200 && httr::status_code(resp) <= 299) {
        api_response$content
      } else if (httr::status_code(resp) >= 300 && httr::status_code(resp) <= 399) {
        api_response
      } else if (httr::status_code(resp) >= 400 && httr::status_code(resp) <= 499) {
        api_response
      } else if (httr::status_code(resp) >= 500 && httr::status_code(resp) <= 599) {
        api_response
      }
    },

    FakeDataFileWithHttpInfo = function(dummy, var_data_file=NULL, data_file = NULL, ...) {
      args <- list(...)
      query_params <- list()
      header_params <- c()

      if (missing(`dummy`)) {
        stop("Missing required parameter `dummy`.")
      }

      body <- NULL
      url_path <- "/fake/data_file"

      resp <- self$api_client$CallApi(url = paste0(self$api_client$base_path, url_path),
                                 method = "GET",
                                 query_params = query_params,
                                 header_params = header_params,
                                 body = body,
                                 ...)

      if (httr::status_code(resp) >= 200 && httr::status_code(resp) <= 299) {
        # save response in a file
        if (!is.null(data_file)) {
            write(httr::content(resp, "text", encoding = "UTF-8", simplifyVector = FALSE), data_file)
        }

        deserialized_resp_obj <- tryCatch(
          self$api_client$deserialize(resp, "User", loadNamespace("petstore")),
          error = function(e) {
             stop("Failed to deserialize response")
          }
        )
        ApiResponse$new(deserialized_resp_obj, resp)
      } else if (httr::status_code(resp) >= 300 && httr::status_code(resp) <= 399) {
        ApiResponse$new(paste("Server returned ", httr::status_code(resp), " response status code."), resp)
      } else if (httr::status_code(resp) >= 400 && httr::status_code(resp) <= 499) {
        ApiResponse$new("API client error", resp)
      } else if (httr::status_code(resp) >= 500 && httr::status_code(resp) <= 599) {
        ApiResponse$new("API server error", resp)
      }
    }
  )
)
